﻿/*
 * ROT.c
 *
 * Created: 20/9/2016 8:10:59 pm
 *  Author: Dimitrios Porlidas
 */ 

#include "LCD_keyb_ROT.h"
															// For ROT type Pulses=detents
ISR(INT0_vect)												// Interrupt INT0, PD2 RotA, CW Increase, start moving rotor (A->0, B=1)
{
//	sei();													// Enable interrupts (if necessary)
//	cli();													// Disable interrupts (if necessary)
	_delay_ms(1);
	while (!(bit_is_set(PIND,2)));							// Wait while A=0
	_delay_ms(1);
	if ((bit_is_set(PIND,2)) && (!(bit_is_set(PIND,3))))	// Rotor moving (A=1, B=0)
	reg1bin++;												// Increase
	while (!(bit_is_set(PIND,3)));							// Wait while B=0
	_delay_ms(1);
//	CountROT ();
}
															// For ROT type Pulses=detents
ISR(INT1_vect)												// Interrupt INT1, PD3 RotB, CCW Decrease, start moving rotor (B->0, A=1)
{
//	sei();													// Enable interrupts (if necessary)
//	cli();													// Disable interrupts (if necessary)
	_delay_ms(1);
	while (!(bit_is_set(PIND,3)));							// Wait while B=0
	_delay_ms(1);
	if ((bit_is_set(PIND,3)) && (!(bit_is_set(PIND,2))))	// Rotor moving (B=1, A=0)
	reg1bin--;												// Decrease
	while (!(bit_is_set(PIND,2)));							// Wait while A=0
	_delay_ms(1);
//	CountROT ();
}

/*															// For ROT type KY40 (2xPulses=Detents)
ISR(INT0_vect)												// Interrupt by the rising edge INT0, PD2 RotA, CW Increase, start moving rotor
{
	GICR &= ~(1<<INT0);										// Disable INT0
	GICR &= ~(1<<INT1);										// Disable INT1
	_delay_ms(1);
	if (bit_is_set(PIND,3))									// If B=1 when interrupt moving CCW
	{
		_delay_ms(1);
		if (bit_is_set(PIND,3))								// Condition for parasitic pulses
		reg1bin--;											// Decrease
	}

	else if (!(bit_is_set(PIND,3)))							// If B=0 when interrupt moving CW
	{
		while (!(bit_is_set(PIND,3)));						// Wait while B=0
		_delay_ms(1);
		reg1bin++;											// Increase
	}

	CountROT ();
	_delay_ms(1);
	GICR |= (1<<INT0);										// Enable INT0
	GICR |= (1<<INT1);										// Enable INT1
}

ISR(INT1_vect)												// Interrupt by the falling edge INT1, PD3 RotB, CW Increase, start moving rotor
{
	GICR &= ~(1<<INT0);										// Disable INT0
	GICR &= ~(1<<INT1);										// Disable INT1
	_delay_ms(1);
	if (bit_is_set(PIND,2))									// If A=1 when interrupt moving CCW
	{
		while ((bit_is_set(PIND,2)));						// Wait while A=1
		_delay_ms(1);
		reg1bin--;											// Degrease
	}
		
	else if (!(bit_is_set(PIND,2)))							// If A=0 when interrupt moving CW
	{
		_delay_ms(1);
		if (!(bit_is_set(PIND,2)))							// Condition for parasitic pulses
		reg1bin++;											// Increase
	}
	
	CountROT ();
	_delay_ms(1);
	GICR |= (1<<INT0);										// Enable INT0
	GICR |= (1<<INT1);										// Enable INT1
}
*/

void InitROT (void)											// Start up, initialization rutine
{
	MCUCR |= (1<<ISC01);									// Interrupt by the falling edge INT0 (For ROT type Pulses=detents)
	MCUCR |= (1<<ISC11);									// Interrupt by the falling edge INT1 (For ROT type Pulses=detents)
//	MCUCR |= (3<<ISC00);									// Interrupt by the rising edge INT0 (For ROT type KY40 2xPulses=Detents)
//	MCUCR |= (1<<ISC11);									// Interrupt by the falling edge INT1 (For ROT type KY40 2xPulses=Detents)
	GICR |= (1<<INT0);										// Enable INT0 interrupt
	GICR |= (1<<INT1);										// Enable INT1 interrupt
	sei();													// Enable interrupts
//	cli();													// Disable interrupts
	DDRD &= ~((1<<2)|(1<<3));								// Port D1, D2 inputs
	PORTD |= (3<<PORTD2);									// Port D1, D2 Enable pull up
}

void CountROT (void)
{
	itoa (reg1bin, reg1asc, 10);							// Counter, Transform binary integer to decimal ASCII string
	SeCu (L1R1);											// Send cursor to a specific address 0-80 (LCD)
	_delay_ms (5);
	for (uint8_t irot = 0; irot < (unsigned)strlen(reg1asc); irot++)	// Send ASCII string to LCD
	WrDa (reg1asc[irot]);									//
	WrDa('A');												// Write A at the end of number
	for (uint8_t irot = (unsigned)strlen(reg1asc); irot < 7; irot++)	// Complete with blanks
	WrDa(' ');
}