﻿/*
 * USART.c
 *
 * Created: 2/12/2017 8:02:35 pm
 *  Author: Dimitrios Porlidas
 */ 

#include "LCD_keyb_ROT.h"

void USART_Init( unsigned int baud )
{
	UBRRH = (unsigned char)(baud>>8);						// Set baud rate
	UBRRL = (unsigned char)baud;
	UCSRB = (1<<RXEN)|(1<<TXEN)|(1<<RXCIE);					// Enable receiver and transmitter, enable receiver complete interrupt 
//	UCSRC = (1<<URSEL)|(1<<USBS)|(3<<UCSZ0);				// Set frame format: 2 stop bit, 8 data, asynchronous operation & no parity (by default)
}

void USART_Transmit( unsigned char trnsm )
{
	while (!( UCSRA & (1<<UDRE)));							// Wait for empty transmit buffer
	UDR = trnsm;											// Put data into buffer, sends the data
}

unsigned char USART_Receive(void)							// USART Receive routine 
{
	while (!(UCSRA & (1<<RXC)));							// Wait for unread data in buffer 
	return UDR;												// Return data to caller 
}

ISR(USART_RXC_vect)											// Receive Complete Interrupt 
{
	rsdata = USART_Receive();								// Send received data to variable rsdata
	entry |= (1<<1);										// Set entry flag
}